// RecordSound.cpp : implementation file
//

#include "stdafx.h"
#include <mmsystem.h>
#include "record.h"
#include "RecordSound1.h"
#include "PlaySound.h"
#include "WriteSoundFile.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRecordSound

IMPLEMENT_DYNCREATE(CRecordSound, CWinThread)





CRecordSound::CRecordSound(int iHertz)
{
	
	
	memset(&m_WaveFormatEx,0x00,sizeof(m_WaveFormatEx));
	m_WaveFormatEx.wFormatTag = WAVE_FORMAT_PCM;
	m_WaveFormatEx.nChannels = 1;
	m_WaveFormatEx.wBitsPerSample = 8;
	m_WaveFormatEx.cbSize = 0;
	m_WaveFormatEx.nSamplesPerSec = iHertz;//20050;
	m_WaveFormatEx.nAvgBytesPerSec = m_WaveFormatEx.nSamplesPerSec
		*(m_WaveFormatEx.wBitsPerSample/8);
	m_WaveFormatEx.nBlockAlign = 
		(m_WaveFormatEx.wBitsPerSample/8)*
		m_WaveFormatEx.nChannels;

	m_bRecording = FALSE;
	m_Player = NULL;
	m_Writer = NULL;
	m_iSoundBuffers=0;
	
}






CRecordSound::~CRecordSound()
{
}

BOOL CRecordSound::InitInstance()
{
	// TODO:  perform and per-thread initialization here
	return TRUE;
}

int CRecordSound::ExitInstance()
{
	// TODO:  perform any per-thread cleanup here
	return CWinThread::ExitInstance();
}

BEGIN_MESSAGE_MAP(CRecordSound, CWinThread)
	//{{AFX_MSG_MAP(CRecordSound)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
	ON_THREAD_MESSAGE(WM_RECORDSOUND_STARTRECORDING, StartRecord)
	ON_THREAD_MESSAGE(WM_RECORDSOUND_STOPRECORDING, StopRecord)

	ON_THREAD_MESSAGE(WM_RECORDSOUND_SOUNDPLAYER, OnPtrSoundPlayer)
	ON_THREAD_MESSAGE(WM_RECORDSOUND_ENDTHREAD, OnEndThread)
	ON_THREAD_MESSAGE(WM_RECORDSOUND_WRITERTHREAD,OnPtrSoundWriter)
END_MESSAGE_MAP()



/////////////////////////////////////////////////////////////////////////////
// CRecordSound message handlers
void CRecordSound::OnPtrSoundPlayer(WPARAM wParam, LPARAM lParam)
{
	m_Player = (CPlaySound*) lParam;
	
	return;
}
void CRecordSound::StartRecord(WPARAM wParam, LPARAM lParam)
{
	DWORD mmReturn = 0;

	if(m_bRecording)
		return;

	if(!m_bRecording)
	{
		// open wavein device
		MMRESULT mmReturn = ::waveInOpen( &m_hRecord, WAVE_MAPPER,
			&m_WaveFormatEx,(DWORD) &OnCallbackBlock, (DWORD)this, CALLBACK_FUNCTION);
		if(mmReturn )
		{
			char errorbuffer[MAX_PATH];
			char errorbuffer1[MAX_PATH];
			waveInGetErrorText( mmReturn, 
								errorbuffer,
								MAX_PATH);
			sprintf(errorbuffer1,"WAVEIN:%x:%s",mmReturn,errorbuffer);

			AfxMessageBox(errorbuffer1);  

		}
	
			
		if(!mmReturn)
		{
			AllocateBuffers(MAXINPUTBUFFERS);
			mmReturn = ::waveInStart(m_hRecord);
			if(mmReturn )
		{
			char errorbuffer[MAX_PATH];
			char errorbuffer1[MAX_PATH];
			waveInGetErrorText( mmReturn, 
								errorbuffer,
								MAX_PATH);
			sprintf(errorbuffer1,"WAVEIN:%x:%s",mmReturn,errorbuffer);

			AfxMessageBox(errorbuffer1);  

		}
	
			if(!mmReturn)
			{
				m_bRecording = TRUE;
				if(m_Player)
					m_Player->PostThreadMessage(WM_PLAYSOUND_STARTPLAYING, 0, 0);				
					if(m_Writer)
					{
						PWRITESOUNDFILE pwsf= (PWRITESOUNDFILE) new WRITESOUNDFILE;
						ZeroMemory(pwsf,sizeof(WRITESOUNDFILE));
						char *p = pwsf->lpszFileName;
						strcpy(p,"sound.wav");
						memcpy(&pwsf->waveFormatEx,&m_WaveFormatEx,sizeof(m_WaveFormatEx));
						m_Writer->PostThreadMessage(
						WM_WRITESOUNDFILE_FILENAME,0,(LPARAM)pwsf);
					}
		
				return;
			}
		}
	

	}
	return;
}
void CRecordSound::AllocateBuffers(int nBuffers)
{
    int i;
	for(i=0; i < nBuffers; i++)
	{
		LPWAVEHDR lpWaveHdr = CreateWaveHeader();
		::waveInPrepareHeader(m_hRecord,lpWaveHdr, sizeof(WAVEHDR));
		::waveInAddBuffer(m_hRecord, lpWaveHdr, sizeof(WAVEHDR));			
		m_iSoundBuffers++;
	}
}

void CRecordSound::StopRecord(WPARAM wParam, LPARAM lParam)
{
	MMRESULT mmReturn = 0;
	if(!m_bRecording)
		return;

	if(m_bRecording)
	{
		m_bRecording = FALSE;
		mmReturn = ::waveInStop(m_hRecord);
		OutputDebugString("waveinstop\n");
		mmReturn = ::waveInReset(m_hRecord);
	
		// give callback time to get rid of spare sound buffers
		Sleep(500);


		if(!mmReturn)
			mmReturn = ::waveInClose(m_hRecord);
		if(m_Player)
			m_Player->PostThreadMessage(WM_PLAYSOUND_STOPPLAYING,0,0);

		if(m_Writer)
			m_Writer->PostThreadMessage(WM_WRITESOUNDFILE_CLOSEFILE,0,0);
		
		return;
	}
	return;
}


// this is a C style callback, not a part of the class
// it receives a instance pointer which is the pointer to
// the CRecordSound class

void CALLBACK OnCallbackBlock(HWAVEIN hwl,UINT uMsg,
				DWORD dwInstance,
				DWORD dwParam1, DWORD dwParam2)
{
	CRecordSound*pCallback = (CRecordSound*)dwInstance;
	if(pCallback)
		pCallback->OnSoundBlock(hwl,uMsg,dwInstance,dwParam1,dwParam2);
}


// this is the callback method which is called when a 
// sound block has been recorded.
// NOTE: once waveinreset() has been called you cannot call
// waveInUnprepareHeader() on the sound blocks returned.
// You must be careful what you call in the callback once
// waveinreset() has been called in the stop method.

void CRecordSound::OnSoundBlock(HWAVEIN hwl,UINT uMsg,
									DWORD dwInstance,
									DWORD dwParam1, DWORD dwParam2)

{
	LPWAVEHDR lpWaveHdr = (LPWAVEHDR) dwParam1;

	if(lpWaveHdr && uMsg == WIM_DATA)
	{
		BYTE * lpInt = (BYTE*) lpWaveHdr->lpData;
		DWORD iRecorded = lpWaveHdr->dwBytesRecorded;
		
		if(m_bRecording)
		 ::waveInUnprepareHeader(m_hRecord, lpWaveHdr, sizeof(WAVEHDR));
       
		ProcessSoundData(lpInt, iRecorded/sizeof(BYTE));
		if(m_Writer && m_bRecording)
		{
			WAVEHDR* pWriteHdr = new WAVEHDR;
			if(!pWriteHdr)
				return;
			memcpy(pWriteHdr,lpWaveHdr,sizeof(WAVEHDR));
			BYTE * pSound = new BYTE[lpWaveHdr->dwBufferLength];
			if(!pSound)
			{
				delete pWriteHdr;
				return;
			}
			memcpy(pSound,lpWaveHdr->lpData,lpWaveHdr->dwBufferLength);
			pWriteHdr->lpData = (char*)pSound;
			m_Writer->PostThreadMessage(WM_WRITESOUNDFILE_WRITEBLOCK,GetCurrentThreadId(),(LPARAM) pWriteHdr);
		}
		

		if(m_Player && m_bRecording)
		{
	
			m_Player->PostThreadMessage(WM_PLAYSOUND_PLAYBLOCK, GetCurrentThreadId(),(LPARAM) lpWaveHdr);
		
		}
		else
		{
			delete lpInt;
			delete lpWaveHdr;
		}
		char debugbuffer[256];
		
		sprintf(debugbuffer, "SOUND BUFFER returned: %d,%d\n",iRecorded,m_iSoundBuffers);
		TRACE(debugbuffer);
		m_iSoundBuffers--;
		if(m_bRecording)
		{
			AllocateBuffers(1);
		}
	
	}


	return;
}

LPWAVEHDR CRecordSound::CreateWaveHeader()
{
	LPWAVEHDR lpWaveHdr = new WAVEHDR;
	ZeroMemory(lpWaveHdr, sizeof(WAVEHDR));
	BYTE* lpByte = new BYTE[(m_WaveFormatEx.nBlockAlign*SOUNDSAMPLES)];

	lpWaveHdr->lpData = (char *) lpByte;
	lpWaveHdr->dwBufferLength = (m_WaveFormatEx.nBlockAlign*SOUNDSAMPLES);
	return lpWaveHdr;

}

void CRecordSound::ProcessSoundData(BYTE* sound, DWORD dwSamples)
{
}
void CRecordSound::OnEndThread(WPARAM wParam, LPARAM lParam)
{
	if(m_bRecording)
	{
		StopRecord(0, 0);
	}
	::PostQuitMessage(0);
	return;
}
void CRecordSound::OnPtrSoundWriter(WPARAM wParam, LPARAM lParam)
{
	m_Writer = (CWriteSoundFile*) lParam;
	return;
}
	